﻿<%@ Control Language="C#" AutoEventWireup="false" CodeBehind="ResponseList.ascx.cs" Inherits="CheckboxWeb.Forms.Surveys.Responses.Controls.ResponseList" %>
<%@ Register TagPrefix="ckbx" TagName="Grid" Src="~/Controls/Grid.ascx" %>
<%@ Import Namespace="Checkbox.Management" %>
<%@ Import Namespace="Checkbox.Web" %>

<script type="text/javascript">
  <%-- Ensure service initialized --%>
    $(document).ready(function() {
        //implementation all/none selection
        $(document).on('click', '.deleteResponse', function(event) {
            toggleGridActionButtons('response', this);
            event.stopPropagation();
        });
        $(document).on('click', '#_selectAllResponses', function() {
            var actionsAvailable = false;
            if ($(this).prop('checked')) {
                actionsAvailable = true;
                $('.deleteResponse').prop('checked', true);
            } else {
                $('.deleteResponse').prop('checked', false);
            }
            $.uniform.update('.deleteResponse');
            toggleGridActionButtons('response', this, actionsAvailable);
        });


        //Bind delete link click
        $('#_deleteSelectedLink').click(function() {
            if ($('.deleteResponse:checked').length > 0) {
                showConfirmDialogWithCallback(
                    '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteSelectedConfirm") %>',
                    onDeleteSelectedConfirm,
                    337,
                    200,
                    '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteSelected") %>'
                );
            }
        });

        $('#_deleteTestLink').click(function() {
            showConfirmDialogWithCallback(
                '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteTestConfirm") %>',
                onDeleteTestConfirm,
                337,
                200,
                '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteTest") %>'
            );
        });

        $('#_deleteAllLink').click(function() {
            showConfirmDialogWithCallback(
                '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteAllConfirm") %>',
                onDeleteAllConfirm,
                337,
                200,
                '<%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteAll") %>'
            );
        });

        statusControl.initialize('_statusPanel');
        
        //if response list is the list of timeline results
        if (<%=TimelinePeriod%>!=0)
           $('#_deleteAllLink').hide();
    });
     
    <%-- Load survey response list --%>
    function loadResponseList(currentPage, sortField, sortAscending, loadCompleteCallback, loadCompleteArgs) {
        loadCompleteArgs['isAggregatedResult'] = '<%=(TimelinePeriod!=0)? "true":null %>';
        svcResponseData.listSurveyResponses(
            _at, 
            <%=SurveyId  %>, 
             {
                pageNumber: currentPage,
                resultsPerPage: <%= ApplicationManager.AppSettings.PagingResultsPerPage %>,
                filterField: '',
                filterValue: '',
                sortField: sortField,
                sortAscending: sortAscending,
                period: <%= TimelinePeriod %>,
                dateFieldName: 'Ended'
            }, 
            loadCompleteCallback,
            loadCompleteArgs
        );       
    }

    //
    function onDeleteSelectedConfirm(args){
        if(args.success){
            var idArray = new Array();

            $('.deleteResponse:checked').each(function(index){
                idArray.push($(this).attr('value'));
            });

            if(idArray.length > 0){
                svcResponseData.deleteSelectedResponses(_at, <%=SurveyId %>, idArray, onResponsesDeleted);
                onResponsesDeleted();
            }
        }
    }

    //
    function onDeleteAllConfirm(args){
        if(args.success){
            svcResponseData.deleteAllSurveyResponses(_at, <%=SurveyId %>, onResponsesDeleted);
            onResponsesDeleted();
        }
    }

    //
    function onDeleteTestConfirm(args){
        if(args.success){
            svcResponseData.deleteTestSurveyResponses(_at, <%=SurveyId %>, onResponsesDeleted);
            onResponsesDeleted();
        }
    }
    
    //
    function onResponsesDeleted(){
        <%=_responseGrid.ReloadGridHandler %>();
        svcResponseData.getResponseSummaryD(_at, <%=SurveyId %>).then(onResponseSummaryGot);
    }

    //
    function onResponseSummaryGot(data) {
        $('#numberOfCompleteResponses').html(data.CompletedResponseCount);
        $('#numberOfIncompleteResponses').html(data.IncompleteResponseCount);
    }

    //
    function onDialogClosed(args)
    {
        if(args && args.action && args.success)
        {
            if (args.action == 'import' && args.success == 'true') {
                <%=_responseGrid.ReloadGridHandler %> ();
            }
        }
    }
    
    //Render Grid comlete handler
    function gridRenderComplete() {
        <%=_responseGrid.ShowSorter %>();
    }
</script>

<div class="gridMenu clearfix">
    <div class="gridSorter left" style="padding: 5px 5px 5px 15px;">
        <%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/numOfComplete")%> : <span id="numberOfCompleteResponses"><%= NumberOfCompleteResponses %></span>
    </div>
    <div class="gridSorter left" style="padding: 5px;">
        <%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/numOfIncomplete")%> : <span id="numberOfIncompleteResponses"><%= NumberOfIncompleteResponses %></span>
    </div>

    <div class="gridButtons itemActionMenu" style="float: right; margin: 0 5px 0 0;">
        <a class="cancelButton" style = "text-decoration: underline" href="#" id="_deleteSelectedLink"><%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteSelected")%></a>
    </div>
    <div class="gridButtons itemActionMenu" style="display: block; float: right;">
        <a class="cancelButton" style = "text-decoration: underline" href="#" id="_deleteAllLink"><%=WebTextManager.GetText("/pageText/forms/surveys/responses/manage.aspx/deleteAll")%></a>    
    </div>
</div>

<%-- Container for Results --%>
<ckbx:Grid ID="_responseGrid" runat="server" GridCssClass="ckbxGrid" />

<%-- Event Handling  --%>
<script type="text/C#" runat="server">
    /// <summary>
    /// Override OnLoad to ensure necessary scripts are loaded.
    /// </summary>
    /// <param name="e"></param>
    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);

        RegisterClientScriptInclude(
           "serviceHelper.js",
           ResolveUrl("~/Services/js/serviceHelper.js"));

        RegisterClientScriptInclude(
            "templateHelper.js",
            ResolveUrl("~/Resources/templateHelper.js"));

        RegisterClientScriptInclude(
           "svcResponseData.js",
           ResolveUrl("~/Services/js/svcResponseData.js"));

        RegisterClientScriptInclude(
            "dateUtils.js",
            ResolveUrl("~/Resources/dateUtils.js"));

        //Moment.js: datetime utilities
        RegisterClientScriptInclude(
            "moment.js",
            ResolveUrl("~/Resources/moment.js"));
        
        RegisterClientScriptInclude(
            "grid.js",
            ResolveUrl("~/Resources/grid.js"));

        RegisterClientScriptInclude(
            "jquery.pager.js",
            ResolveUrl("~/Resources/jquery.pager.js"));
    }
</script>